Bug 1277271 - Review Request: rubygem-algorithms - Useful algorithms and data structures for Ruby
Review Request: rubygem-algorithms - Useful algorithms and data structures fo...
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adam Miller
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-11-02 16:35 EST by Joel Smith
Modified: 2015-11-11 14:22 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
admiller: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Joel Smith 2015-11-02 16:35:05 EST
This is my first package and I'm seeking a sponsor.

Spec URL: http://pkgs-joelsmith.rhcloud.com/rubygem-algorithms/rubygem-algorithms.spec
SRPM URL: http://pkgs-joelsmith.rhcloud.com/rubygem-algorithms/rubygem-algorithms-0.6.1-1.fc21.src.rpm
Description: Ruby Gem that adds support for various data structures and algorithms: Heap, Priority Queue, Deque, Stack, Queue, Red-Black Trees, Splay Trees, sorting algorithms, and more.
Fedora Account System Username: joelsmith
Comment 1 Upstream Release Monitoring 2015-11-02 18:13:45 EST
maxamillion's scratch build of rubygem-algorithms-0.6.1-1.fc21.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11677587
Comment 2 Adam Miller 2015-11-02 18:23:09 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- gems should require rubygems package
  Note: Requires: rubygems missing in rubygem-algorithms-doc
  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
- Pure Ruby package must be built as noarch
- Package contains Requires: ruby(release).


===== MUST items =====

C/C++:
[-]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 52 files have unknown license. Detailed
     output of licensecheck in /home/admiller/reviews/1277271-rubygem-
     algorithms/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gems,
     /usr/share/gems/doc
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[-]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     algorithms-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
     Koji Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11677587
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Gem should use %gem_install macro.
[x]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %exclude
     /usr/share/gems/cache/algorithms-0.6.1.gem,
     /usr/share/gems/specifications/algorithms-0.6.1.gemspec
[x]: Gem package should exclude cached Gem.
[x]: Test suite should not be run by rake.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-algorithms-0.6.1-1.fc24.x86_64.rpm
          rubygem-algorithms-doc-0.6.1-1.fc24.noarch.rpm
          rubygem-algorithms-0.6.1-1.fc24.src.rpm
rubygem-algorithms.x86_64: W: no-documentation
rubygem-algorithms.x86_64: E: zero-length /usr/lib64/gems/ruby/algorithms-0.6.1/gem.build_complete
rubygem-algorithms.src:78: W: macro-in-comment %{gem_instdir}
3 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (debuginfo)
-------------------
Checking: rubygem-algorithms-debuginfo-0.6.1-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
rubygem-algorithms.x86_64: W: no-documentation
rubygem-algorithms.x86_64: E: zero-length /usr/lib64/gems/ruby/algorithms-0.6.1/gem.build_complete
3 packages and 0 specfiles checked; 1 errors, 1 warnings.



Requires
--------
rubygem-algorithms (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcrypt.so.1()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libruby.so.2.2()(64bit)
    rtld(GNU_HASH)
    ruby(rubygems)

rubygem-algorithms-doc (rpmlib, GLIBC filtered):
    rubygem-algorithms



Provides
--------
rubygem-algorithms:
    rubygem(algorithms)
    rubygem-algorithms
    rubygem-algorithms(x86-64)

rubygem-algorithms-doc:
    rubygem-algorithms-doc



Unversioned so-files
--------------------
rubygem-algorithms: /usr/lib64/gems/ruby/algorithms-0.6.1/CBst.so
rubygem-algorithms: /usr/lib64/gems/ruby/algorithms-0.6.1/CDeque.so
rubygem-algorithms: /usr/lib64/gems/ruby/algorithms-0.6.1/CRBTreeMap.so
rubygem-algorithms: /usr/lib64/gems/ruby/algorithms-0.6.1/CSplayTreeMap.so
rubygem-algorithms: /usr/lib64/gems/ruby/algorithms-0.6.1/CString.so

Source checksums
----------------
https://rubygems.org/gems/algorithms-0.6.1.gem :
  CHECKSUM(SHA256) this package     : c5cee5cb10bb5810fbc12b8cd52fc53ebf993bc351e122f7214d64b13aa6f28a
  CHECKSUM(SHA256) upstream package : c5cee5cb10bb5810fbc12b8cd52fc53ebf993bc351e122f7214d64b13aa6f28a


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1277271 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Ruby, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

===== NOTES =====

The only thing I see that needs fixing is the zero-length file that rpmlint is complaining about. Otherwise this looks good. Please fix that and I'll approve the package.
Comment 3 Upstream Release Monitoring 2015-11-05 10:46:25 EST
joelsmith's scratch build of rubygem-algorithms-0.6.1-1.fc21.src.rpm for f21 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11717477
Comment 4 Joel Smith 2015-11-05 10:55:53 EST
Thanks for the review. AFAICT, that empty file is supposed to be there... it's a touch file that indicates that the gem has been built. Apparently rubygems has a lazy build system:

"Builds extensions for this platform if the gem has extensions listed and the gem.build_complete file is missing."

However, to keep rpmlint happy, I added a build step to add a single newline to the file if it exists. The rpmlint error is now gone on my system.
Comment 5 Adam Miller 2015-11-09 10:46:38 EST
APPROVED
Comment 6 Gwyn Ciesla 2015-11-11 14:22:53 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rubygem-algorithms

Note You need to log in before you can comment on or make changes to this bug.